/************************************************************************
 *	Copyright (C) 1998. Bernoulli Project, Cornell University.	*
 ************************************************************************/
/* Vladimir Kotlyar  February 1996
 *
 *
 *
 */

#ifndef _a_fmve_h
#define _a_fmve_h

#ifndef _a_fmve_private_h
#include "alpha_fmve_private.h"
#endif


/***********************************************************************
 *			     PROJECTIONS
 ***********************************************************************/

typedef xa_proj  AlphaProjection;

#define a_X0_proj(p)			xa_X0_proj(p)
#define a_H_proj(p)			xa_H_proj(p)
#define a_ineq_list_proj(p)		xa_ineq_list_proj(p)
#define a_nvars_proj(p)			xa_nvars_proj(p)
#define a_nprot_proj(p)			xa_nprot_proj(p)
#define a_is_tautology_proj(p)          xa_is_tautology_proj(p)
#define a_is_single_value_proj(p)       xa_is_single_value_proj(p)
#define a_is_hyperplane_proj(p)         xa_is_hyperplane_proj(p)
#define a_is_full_proj(p)               xa_is_full_proj(p)
#define a_is_final_proj(p)		xa_is_final_proj(p)


/***********************************************************************
 *			 LISTS OF PROJECTIONS
 ***********************************************************************/

typedef xa_proj_list AlphaProjList;

#define a_car_proj_list(l)		xa_car_proj_list(l)
#define a_cdr_proj_list(l)		xa_cdr_proj_list(l)

/***********************************************************************
 *		     DECISION PROCEDURE INTERFACE
 ***********************************************************************/

/*
 * In the functions below:
 *  A and B give a system of equalities Ax == B
 *  F and G give a system of inequalities Fx <= G
 */

int		a_decide_eq_and_ineq (arena_info *arena, AlphaMatrix A, AlphaVector B,
				      AlphaMatrix F, AlphaVector G);
int		a_decide_ineq (arena_info *arena, AlphaMatrix F, AlphaVector G);



/***********************************************************************
 *		    SYMBOLIC PROJECTION INTERFACE
 ***********************************************************************/


#define a_set_splinter_symbolic(f)	(xa_splinter_symbolic = (f))


/*
 * Project away all variable except for the first nprot
 */
AlphaProjList   a_symbolic_projection (arena_info *arena, int nprot, 
				       AlphaMatrix A, AlphaVector B,
				       AlphaMatrix F, AlphaVector G);

void		a_print_proj_list (FILE *fp, AlphaProjList l);

#endif
