/************************************************************************
 *	Copyright (C) 1998. Bernoulli Project, Cornell University.	*
 ************************************************************************/
#include "./config.h"

#include <stdio.h>
#include "alpha_matrix.h"

int main()
{
    AlphaMatrix U, B, X;
    int m, n;
    arena_info *arena = a_arena_make ();

    scanf ("%d%d", &n, &m);
    U = a_make_matrix (arena, n, n);
    B = a_make_matrix (arena, n, m);
    X = a_make_matrix (arena, n, m);

    a_read_matrix (stdin, U);
    a_read_matrix (stdin, B);

    a_block_unit_backsolve (U, B, X);

    a_dump_matrix (stdout, U);
    a_dump_matrix (stdout, B);
    a_dump_matrix (stdout, X);

    a_arena_free (arena);

    return 0;
}
