(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Containers

open Bmf;;
open Bb;;

(* BB array decl parsing stuff *)

exception Not_a_bb_decl of string;;
val extract_bb_directive : bmf_ident -> string * keyword_list;;

exception No_such_bb_registered of string;;
val black_box_of_bb_decl : bmf_ident -> black_box;;
val make_black_box_obj :
    (*bb_name*) string -> (*bb_args*) keyword_list -> black_box;;

val black_box_of_dense_decl : bmf_ident -> black_box;;

val find_method : string -> black_box -> access_method;;

val all_fields_in_black_box : black_box -> string list;;

val black_box_of_view_decl : bmf_ident -> black_box;;

type black_box_map = black_box String_map.t;;
val empty_black_box_map : black_box_map

val add_array_decls : bmf_ident list -> black_box_map -> black_box_map
