(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Containers

val an_expr_arg :
  Bmf.annotation String_map.t ->
  string -> (unit -> Bmf.bmf_expr) -> Bmf.bmf_expr
val an_expr_var_arg :
  Bmf.annotation String_map.t -> string -> (unit -> string) -> string
val an_string_arg :
  Bmf.annotation String_map.t -> string -> (unit -> string) -> string
val an_type_list_arg :
  Bmf.annotation String_map.t -> string -> (unit -> Bmf.bmf_type list) -> 
    Bmf.bmf_type list
val an_type_arg :
  Bmf.annotation String_map.t -> string -> (unit -> Bmf.bmf_type) -> 
    Bmf.bmf_type
val required : ('a -> string -> (unit -> 'b) -> 'c) -> 'a -> string -> 'c
val gen_binary_search :
  Bmf.bmf_expr ->
  Bmf.bmf_expr ->
  Bmf.bmf_expr ->
  string ->
  (Bmf.bmf_expr -> Bmf.bmf_stmt) -> (unit -> Bmf.bmf_stmt) -> Bmf.bmf_stmt
val interval_bounds0 :
  string ->
  Bmf.annotation String_map.t -> Bmf.bmf_expr list -> Bmf.bmf_expr
val rectangular_bounds0 :
  string ->
  string ->
  Bmf.annotation String_map.t -> Bmf.bmf_expr list -> Bmf.bmf_expr
val rectangular_bounds1 :
  string ->
  string ->
  Bmf.annotation String_map.t -> Bmf.bmf_expr list -> Bmf.bmf_expr
val triangular_bounds :
    Bmf.bmf_expr -> Bmf.bmf_expr ->
      bool -> bool -> bool ->
	Bmf.bmf_expr list -> Bmf.bmf_expr
val output_access_method : out_channel -> Bb.access_method -> unit
val output_access_method_kind : out_channel -> Bb.access_method_kind -> unit
