type token =
    VOID
  | BOOL
  | REAL
  | INT
  | DOTDOT
  | DOT
  | ARRAY
  | PTR
  | OF
  | ON
  | COMMA
  | PARAMBEGIN
  | PARAMEND
  | PLUS
  | MINUS
  | STAR
  | DIVIDE
  | AND
  | OR
  | NOT
  | IMPLIES
  | FORALL
  | EXIST
  | TRUE0
  | FALSE0
  | POWER
  | SQRT0
  | ADDR
  | OPEN_PAREN
  | CLOSE_PAREN
  | OPEN_CURLY
  | CLOSE_CURLY
  | OPEN_SQUARE
  | CLOSE_SQUARE
  | OPEN_ANN
  | CLOSE_ANN
  | COLON
  | BAR
  | SEMI_COLON
  | ASSIGN
  | LEFT_ARROW
  | EQUALS
  | LE
  | LTHAN
  | GT
  | GE
  | NEQ
  | WHILE0
  | IF0
  | ELSE
  | FOR0
  | DO0
  | CALL0
  | OP0
  | EXTERN
  | PROCEDURE
  | SUCH
  | THAT
  | VAR
  | RELATION
  | TYPE_ANN
  | STRINGVAL of (string)
  | DECIMALINT of (int)
  | FLOAT of (float)
  | IDENT of (string)
  | EOF
  | IN_PLACE_TYPE of (Bmf.bmf_type)
  | IN_PLACE_STMT of (Bmf.bmf_stmt)
  | IN_PLACE_EXPR of (Bmf.bmf_expr)
  | IN_PLACE_STRING of (string)
  | IN_PLACE_STMT_LIST of (Bmf.bmf_stmt list)
  | IN_PLACE_EXPR_LIST of (Bmf.bmf_expr list)
  | IN_PLACE_STRING_LIST of (string list)
  | IN_PLACE_EMPTY_LIST

val int_matrix :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Alpha.matrix
val int_vector :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Alpha.vector
val int_affine_map :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf_linear.affine_map
val file :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.bmf_ident list
val statement_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.bmf_stmt
val expression_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.bmf_expr
val vars_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.bmf_ident list
val annotation_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.annotation
val ident_entry :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> Bmf.bmf_ident
