(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Alpha;;
open Bmf;;
open Bmf_linear;;

exception Parser_Error of string;;
exception Parser_String_Error of string * string;;

val parse_channel : in_channel -> bmf_ident list;;
val parse_file : string -> bmf_ident list;;
val parse_stdin : unit -> bmf_ident list;;
val parse_matrix : string -> matrix;;
val parse_vector : string -> vector;;
val parse_affine_map : string -> affine_map;;
val parse_stmt : string -> (string * annotation) list -> bmf_stmt;;
val parse_expr : string -> (string * annotation) list -> bmf_expr;;
val parse_annot : string -> (string * annotation) list -> annotation;;
val parse_ident : string -> (string * annotation) list -> bmf_ident;;
val parse_vars : string -> (string * annotation) list -> bmf_ident list;;

exception M4Failure

val do_m4_preproc : 
    ((*m4cmd:*) string) -> ((*m4opts:*) string) -> 
	((*infile_name:*) string) -> ((*outfile_name:*) string)
