(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Bmf;;

val unparse_channel : out_channel -> int (*right margin*)
    -> bmf_ident list -> unit;;
val unparse_file : string -> int (*right margin*)
    -> bmf_ident list -> unit;;
val unparse_stdout : int (*right margin*)
    -> bmf_ident list -> unit;;

val idents_printer : Format.formatter -> bmf_ident list -> unit;;
val ident_printer : Format.formatter -> bmf_ident -> unit;;
val stmt_printer : Format.formatter -> bmf_stmt -> unit;;
val expr_printer : Format.formatter -> bmf_expr -> unit;;
val type_printer : Format.formatter -> bmf_type -> unit;;
val annotation_printer : Format.formatter -> annotation -> unit;;

(* Routines for removing tags from gensym'ed identifiers whereever
   possible. *)

val normalize_global : bmf_ident -> bmf_ident
val normalize_globals : bmf_ident list -> bmf_ident list

