(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Bsct_base

let read_bmf infile_s =
  try 
    let code =
      if Scheme.string_p infile_s then
	Bmf_parser_aux.parse_file (Scheme.untag_string infile_s)
      else if infile_s == Scheme.sharp_t then
	Bmf_parser_aux.parse_stdin ()
      else
	raise (Scheme.Bad_arg("read-bmf",infile_s))
    in
    Sx.to_scheme (Bmf.to_s_expr code) 
  with exn ->
    raise (Failure (Printexc.to_string exn))

let _ = Scheme.define_prim1 (Scheme.interaction_environment ())
    "read-bmf" read_bmf

let _ = Scheme.main ()
