(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Bsct_base

(* expressions *)
module E : Expr.E with module ATOM = SimpleAtom 

(* lambda expressions *)
module L : 
    Lambda_expr.L with module Ex = E and
	module Key = SimpleAtom
 
(* lambdas + affine stuff *)
module L_affine : 
    Lambda_affine.L_affine with module L = L

module A : Affine.A with type atom = string and type expr = E.expr

module Convert :
  sig
    exception Invalid_s_expr of Sx.t
    val from_sexpr : Sx.t -> E.expr
    val to_sexpr : E.expr -> Sx.t
  end

(*********
val gensym : unit -> string
val gensyms : int -> string list
*********)

module L_convert : 
    sig
      val parse_desc : Sx.t -> L.descriptor
      val unparse_desc : L.descriptor -> Sx.t
      val parse : Sx.t -> L.t
      val unparse : L.t -> Sx.t
    end


