(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
(******************************************************************)

type
  'a matrix = {rows:int ; cols:int ; mutable mx:('a vect vect)}
and
  'a vector = {length:int ; mutable vec:('a vect)}
;;

type
  'a transpose_builder =
    transpose_matrix of 'a matrix
  | transpose_vector of 'a vector
;;

exception invalid_matrix_sizes of int list;;
exception out_of_list_bounds of unit;;

value ith_in_list : 'a list -> int -> 'a;;
value new_matrix : int -> int -> 'a -> 'a matrix;;
value new_vector : int -> 'a -> 'a vector;;
value matrix_of_vect_list : 'a vector list -> 'a matrix;;
value dot_prod : int vector -> int vector -> int;;
value saxpy : int -> int vector -> int -> int vector -> int vector;;
value mvm : int matrix -> int vector -> int vector;;
value mmm : int matrix -> int matrix -> int matrix;;
value create_identity : int -> int matrix;;
value is_zero_matrix : int matrix -> bool;;
value is_zero_vector : int vector -> bool;;
value is_identity : int matrix -> bool;;
value transpose : int transpose_builder -> int matrix;;
value matrix2string : int matrix -> string;;
value vector2string : int vector -> string;;
value extract_matrix : int matrix -> int -> int -> int -> int -> int matrix;;
value extract_vector : int vector -> int -> int -> int vector;;
value add_cols2matrix : int -> int matrix -> int matrix;;
value stack_matrices : int matrix -> int matrix -> int matrix;;
value concat_vectors : int vector -> int vector -> int vector;;









