/************************************************************************
 *	Copyright (C) 1998. Bernoulli Project, Cornell University.	*
 ************************************************************************/
#include <assert.h>
#include "hash.h"

#ifndef BMF_INTRINSICS_DEFINED
#define BMF_INTRINSICS_DEFINED
#ifdef __cplusplus
static inline int MIN(int x,int y) {
    if (x < y) return x; else return y; }
static inline int MAX(int x,int y) {
    if (x > y) return x; else return y; }
static inline double MIN(double x,double y) {
    if (x < y) return x; else return y; }
static inline double MAX(double x,double y) {
    if (x > y) return x; else return y; }
#else
#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define MAX(x,y) ((x) > (y) ? (x) : (y))
#endif
#endif

#ifdef __cplusplus
inline
#endif
void genb_test(int n, int Xptr, int Yptr, int *Qptr, int npart, double *sum, int B);

#ifdef __cplusplus
inline
#endif
void genb_test(int n, int Xptr, int Yptr, int *Qptr, int npart, double *sum, int B)
{
    int P = npart;
    double sum__32 = 0;
    int d__33 = 0;
    sum__32 = *(sum);
    d__33 = npart+1;
    {
        sum__32 = 0;
        {
            char valid_p__30 = 0;
            int it__31 = 0;
            int Yit__9 = 0;

            it__31 = open_hash_iter(Yptr);
            valid_p__30 = valid_hash_iter(it__31);
            while (valid_p__30) {
                Yit__9 = it__31;
                {
                    int i__20 = 0;

                    i__20 = deref_hash_iter_as_int(Yit__9,1+-(1));
                    if (1<=i__20&&i__20<=n) {
                        int d__34 = 0;
                        char valid_p__22 = 0;
                        int it__23 = 0;
                        static int *tuple__21 = 0;
                        static int tuple__21_len = 0;
                        d__34 = 0+1;
                        {
                            int new_len__35 = 0+1;
                            if (tuple__21_len < new_len__35 && tuple__21) {
                                free(tuple__21);
                                tuple__21 = 0;
                                tuple__21_len = 0;
                            }
                            if (tuple__21 == 0) {
                                tuple__21 = (int *)calloc(2*new_len__35,sizeof(int));
                                tuple__21_len = 2*new_len__35;
                            }
                        }

                        tuple__21[1+-(1)] = i__20;
                        it__23 = open_hash_iter(Xptr);
                        search_hash_table(it__23,tuple__21);
                        valid_p__22 = valid_hash_iter(it__23);
                        if (valid_p__22) {
                            int low__24 = 0;
                            int mid__25 = 0;
                            int hig__26 = 0;

                            low__24 = 0;
                            hig__26 = npart;

                            assert (!(Qptr[hig__26]<=i__20));
                            assert (!((Qptr[low__24])>(i__20)));

                            while ((hig__26+-(low__24))>(1)) {
                                mid__25 = (low__24+hig__26)/2;
                                if (Qptr[mid__25]<=i__20) {
                                    low__24 = mid__25;
                                }
				else {
                                    hig__26 = mid__25;
                                }

                            }

                            { 
				int Gxx__16; 
				for (Gxx__16=i__20+-(Qptr[low__24]);
				     Gxx__16<=i__20+-(Qptr[low__24]);Gxx__16+=1) {
				    double v__27 = 0;
				    
				    v__27 = deref_hash_iter_as_real(it__23,1);
				    {
					double v__28 = 0;
					
					v__28 = deref_hash_iter_as_real(Yit__9,1);
					sum__32 = sum__32 + v__27 * v__28;
					assert ((low__24 == (i__20-1) / B) &&
						(Gxx__16 == (i__20-1) % B));
					/* sum__32 = sum__32+
					   low__24*i__20*-(-(Gxx__16))*v__27*v__28;*/
				    }

				}
			    }
                        }

                    }

                }

                next_hash_iter(it__31);
                valid_p__30 = valid_hash_iter(it__31);
            }

            close_hash_iter(it__31);
        }

    }
    *sum = sum__32;
}

