(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Containers

open Bb;;
open Bb_decl;;
open Bmf_query;;
open Bmf_join;;
open Scheduler_types;;

(************************************************************************
Terms from the hierarchies of indices
************************************************************************)
type hterm_kind =
| Hterm_enum_simple
    of named_access_method    (* the enun_m for the join var *)
| Hterm_enum_indexing
    of named_access_method    (* the enum_m *)
     * named_access_method    (* the lookup_m for the join var *)
| Hterm_enum_searching
    of named_access_method    (* the enun_m *)
     * named_access_method    (* the lookup_m for the join var *)
     * named_access_method    (* the search_m on the join var *)
| Hterm_lookup
    of named_access_method    (* the lookup_m for the join var *)
;;

val output_hterm_kind : out_channel -> hterm_kind -> unit;;

val mthds_of_hterm : hterm_kind -> named_access_method list;;
val primary_field_of_hterm : hterm_kind -> field_name;;
val rel_of_hterm : hterm_kind -> string;;
val bound_by_hterm : hterm_kind -> bound_type;;

val compute_ready_hterms:
    (*bbm*) black_box_map ->
    (*rel_to_qb_m*) query_binding String_map.t ->
    (*bound*) bound_type ->
    hterm_kind list
;;

val gen_join_term_kind:
    hterm_kind -> (named_access_method -> join_term_equality) ->
    join_term_kind
;;
