(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
(* Catches and prints Scheme errors during the execution of thunk. Other
   errors are passed through. *)
val print_scheme_error : (*thunk*)(unit -> 'a) -> 'a

(* A Read-Eval-Print-Loop.

   o print the prompt.
   o Reads forms from (current_input_port ()).
   o Evaluates these forms in the (interaction_environment ()).
   o Prints the result to (current_output_port ()).
   o Loops

   terminates when EOF is detected on input. Catches Scheme errors, prints
   them, and continues execution. *)

val repl : (*prompt*) string -> unit

(* A high-level entry point to the interpreter.
   This routine parses the command line, loads sim.scm, which contains part
   of the Scheme functionality, and then starts a repl. This routine is
   usually used by placing the line, "let _ = Scheme.main ()" at the bottom
   of a file. *)

val main : unit -> unit
