(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
(************************************************************************)
(* sim_types.mli - Basic types of the SIM.				*)
(************************************************************************)

(* The type of S-expr's in the SIM. See sim_s_exprs.mli for routines for
   manipulating this type. *)
type t

(* The type of primitive functions and closures. See sim_s_exprs.mli for
   routines for manipulating this type. *)
and procedure

(* The type of environments, which map symbols to binding_type's.
   Binding_type's are used to represent the denotations of identifiers. See
   sim_env.mli for routines to manipulate these types. *)
and env_type
and binding_type =
    Special of (t -> env_type -> t)
  | Macro of (t -> t)
  | Variable of (t ref)

(* The types of input and output ports. See sim_io.mli for routines to
   manipulate these types. *)
and input_port
and output_port
