(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Ssisl
open Bsct_base
open Expr_string

(*********************************************************)
(* define the primitive within the Scheme interaction environment. *)
let _ = 
  Scheme.define_prim0 (Scheme.interaction_environment ())
    "l_debug" (fun () -> L.debug_on (); Scheme.nil)

and _ =
  Scheme.define_prim0 (Scheme.interaction_environment ())
    "alpha_debug" (fun () -> Alpha.debug_on (); Scheme.nil)

and _ =
  Scheme.define_prim0 (Scheme.interaction_environment ())
    "affine_debug" (fun () -> Expr_string.A.debug_on (); Scheme.nil)

(*********************************************************)
(*********************************************************)  

let _ = 
  (Lambda_scheme.attach (Scheme.interaction_environment ()) "l-");
  (Rel_expr.attach (Scheme.interaction_environment ()) "rel-");
  (Spmd.Calc.attach (Scheme.interaction_environment ()) "spmd-");
  ()

(* Run the interpreter. *)
let _ = Scheme.main ()

