(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Array

let insert arr i x =
  (* creates a new array arr' with:
  	 arr[0..i-1] == arr'[0..i-1]
  	 arr'[i] == x
  	 arr[i..n-1] == arr'[i+1..n] 
     *)
  let n = length arr in
  zassert (i<=n && i>=0) (Invalid_argument("array_insert"));
  (concat
     [ (sub arr 0 i) ;
       (make 1 x) ;
       (sub arr i (n-i)) ])

let delete arr i =
  let n = length arr in
  zassert (i<n && i>=0) (Invalid_argument("array_delete"));
  (append (sub arr 0 i) (sub arr (i+1) (n-i-1)))

