(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
(************************************************************************)
    
let call_with_open_input_file str f =
  let inchan = open_in str
  in let result = 
    try
      f inchan
    with exn ->
      close_in inchan;
      raise exn
  in
  close_in inchan;
  result
    ;;
    
let call_with_open_output_file str f =
  let outchan = open_out str
  in let result = 
    try
      f outchan
    with exn ->
      close_out outchan;
      raise exn
  in
  close_out outchan;
  result
    ;;
    
(************************************************************************)

let output_list output_elem outch lst =
  output_string outch "[";
  (match lst with
    [] -> ()
  | hd::tl ->
      let rec iter lst =
	(match lst with
	  [] -> ()
	|  hd::tl ->
	    output_string outch "; ";
	    output_elem outch hd;
	    iter tl)
      in
      output_elem outch hd;
      iter tl);
  output_string outch "]"
;;

let output_array output_elem outch a =
  output_string outch "[|";
  for i = 0 to Array.length a - 1 do
    if i > 0 then output_string outch "; ";
    output_elem outch a.(i)
  done;
  output_string outch "|]"
;;

