(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
module type S =
  sig
    type key
    type stuff
    type t

    val empty : t
    val add : t -> key -> stuff -> t
    val absorb_list : t -> (key * stuff) list -> t
    val find : t -> key -> stuff
    val remove : t -> key -> t
    val fold: (key -> stuff -> 'b -> 'b) -> t -> 'b -> 'b
  end

module type Table_entries =
  sig
    type t 
    type u
    val compare : t -> t -> int
  end

module Make(TE : Table_entries) : 
    S with type key = TE.t and type stuff = TE.u

