(************************************************************************)
(*	Copyright (C) 1998. Bernoulli Project, Cornell University.	*)
(************************************************************************)
open Bsct_base

let prim_tautology_p scheme_arg =
  try
    let ml_arg = Sx.from_scheme scheme_arg in
    let wff_arg = Wff.Simple.from_sexpr ml_arg in
    let bool_result = Wff.Simple.tautology_p wff_arg in
    let ml_result = Sx.Bool(bool_result) in
    let scheme_result = Sx.to_scheme ml_result in
    scheme_result
  with
    (SimpleAtom.Invalid_s_expr(x)) ->
      raise (Scheme.Bad_arg("tautology?", Sx.to_scheme x))
  | (Wff.Simple.Invalid_s_expr(x)) ->
      raise (Scheme.Bad_arg("tautology?", Sx.to_scheme x))

let _ = Scheme.define_prim1 (Scheme.interaction_environment ())
    "tautology?" prim_tautology_p

let _ = Scheme.main ()
